package de.ul.mds.pprl.bloom;

import de.ul.mds.pprl.bloom.harden.*;
import org.junit.jupiter.api.Test;

import java.math.BigInteger;
import java.nio.charset.StandardCharsets;
import java.util.*;
import java.util.random.RandomGeneratorFactory;

import static org.junit.jupiter.api.Assertions.*;

public class CLKUtilsTest {

    @Test
    public void testDoubleHash() {
        CLK clk = new CLK(20);
        CLKUtils.doubleHash(clk, 5, 2, 3);

        Set<Integer> expectedBits = Set.of(5, 8, 11, 14, 17);

        for (int i = 0; i < clk.getSize(); i++) {
            if (expectedBits.contains(i)) {
                assertTrue(clk.getBitSet().get(i));
            } else {
                assertFalse(clk.getBitSet().get(i));
            }
        }
    }

    @Test
    public void testEnhancedDoubleHash() {
        CLK clk = new CLK(50);
        CLKUtils.enhancedDoubleHash(clk, 5, 2, 3);

        Set<Integer> expectedBits = Set.of(5, 8 + 1, 11 + 4, 14 + 10, 17 + 20);

        for (int i = 0; i < clk.getSize(); i++) {
            if (expectedBits.contains(i)) {
                assertTrue(clk.getBitSet().get(i));
            } else {
                assertFalse(clk.getBitSet().get(i));
            }
        }
    }

    @Test
    public void testRandomHash() {
        CLK clk = new CLK(50);
        CLKUtils.randomHash(clk, 5, 10, RandomGeneratorFactory.getDefault());

        // first 5 ints generated by default rng with seed=10
        Set<Integer> expectedBits = Set.of(7, 1, 41, 46, 22);

        for (int i = 0; i < clk.getSize(); i++) {
            if (expectedBits.contains(i)) {
                assertTrue(clk.getBitSet().get(i));
            } else {
                assertFalse(clk.getBitSet().get(i));
            }
        }
    }

    private static final byte[] INPUT_BYTES = "foobar".getBytes(StandardCharsets.UTF_8);

    private static String bytesToHex(byte[] bytes) {
        String s = new BigInteger(1, bytes).toString(16);

        if (s.length() % 2 == 1) {
            s = "0" + s;
        }

        return s;
    }

    @Test
    public void testHash() {
        // echo -n "foobar" | md5sum
        assertEquals("3858f62230ac3c915f300c664312c63f", bytesToHex(CLKUtils.computeHash("MD5", INPUT_BYTES)));
    }

    @Test
    public void testHashThrowsOnUnknownHashFunction() {
        assertThrows(IllegalArgumentException.class, () -> CLKUtils.computeHash("foobar", INPUT_BYTES));
    }

    @Test
    public void testHashHMAC() {
        // echo -n "foobar" | openssl md5 -hmac "secret"
        assertEquals("c52fa63f4d2ea54d30b0cdeff523305e", bytesToHex(CLKUtils.computeHmac("HmacMD5", INPUT_BYTES, "secret".getBytes(StandardCharsets.UTF_8))));
    }

    @Test
    public void testHashHMACThrowsOnUnknownHashFunction() {
        assertThrows(IllegalArgumentException.class, () -> CLKUtils.computeHmac("foobar", INPUT_BYTES, "secret".getBytes(StandardCharsets.UTF_8)));
    }

    @Test
    public void testHashHMACThrowsOnIllegalKey() {
        assertThrows(IllegalArgumentException.class, () -> CLKUtils.computeHmac("HmacSHA256", INPUT_BYTES, new byte[0]));
    }

    @Test
    public void testBytesToLong() {
        assertEquals(0x0123456789abcdefL, CLKUtils.bytesToLong(new byte[] {0x01, 0x23, 0x45, 0x67, (byte) 0x89, (byte) 0xab, (byte) 0xcd, (byte) 0xef}));
    }

    @Test
    public void testSplitLongToInt() {
        assertEquals(0x01234567, CLKUtils.splitLongToInt(0x0123456789abcdefL));
    }

    @Test
    public void testSplitLongToInts() {
        assertArrayEquals(new int[] {0x01234567, 0x89abcdef}, CLKUtils.splitLongToInts(0x0123456789abcdefL));
    }

    @Test
    public void testChainHardenersOrder() {
        var permuteHardener = new PermuteHardener(() -> RandomGeneratorFactory.getDefault().create(123L));
        var xorFoldHardener = new XORFoldHardener();

        byte[] bytes = new byte[128];
        RandomGeneratorFactory.getDefault().create(727L).nextBytes(bytes);

        CLK c1 = CLK.wrap(BitSet.valueOf(bytes), bytes.length * 8);
        CLK c2 = CLK.wrap(BitSet.valueOf(bytes), bytes.length * 8);

        assertNotEquals(CLKUtils.chainHardeners(c1, List.of(permuteHardener, xorFoldHardener)),
                CLKUtils.chainHardeners(c2, List.of(xorFoldHardener, permuteHardener)));
    }

    @Test
    public void testOptimalFilterSize() {
        assertEquals(8, CLKUtils.optimalCLKSize(.5d, 5));
        assertEquals(18, CLKUtils.optimalCLKSize(.75d, 5));
        assertEquals(30, CLKUtils.optimalCLKSize(.5, 20));
        assertThrows(IllegalArgumentException.class, () -> CLKUtils.optimalCLKSize(-.01d, 20));
        assertThrows(IllegalArgumentException.class, () -> CLKUtils.optimalCLKSize(.5d, 0));
        assertThrows(IllegalArgumentException.class, () -> CLKUtils.optimalCLKSize(1d, 20));
    }

}
